<template>
  <div class="container skill-card-background-color">
    <div
      class="card"
      target="_blank"
      ref="card"
      @mousemove="move"
      @mouseleave="leave"
    >
      <div>
        <div
          class="circle"
          ref="circle"
        >
          <CircleProgress
            :percent="skill.percent"
            :viewport="true"
            :is-gradient="true"
            :transition="2500"
            :gradient="{
              startColor: startColor,
              stopColor: endColor
            }"
            :is-bg-shadow="true"
            :bg-shadow="{
              vertical: 2,
              horizontal: 2,
              blur: 4,
              opacity: .8,
              color: '#000000'
            }"
          />
        </div>
        <div class="container skillName">
          <h5><b>{{ skill.name }}</b></h5>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CircleProgress from 'vue3-circle-progress'
import 'vue3-circle-progress/dist/circle-progress.css'
import styles from './SkillCard.vue?vue&type=style&index=0&lang=scss&module=1'

export default {

  name: 'SkillCard',
  props: {
    initialSkill: {
      type: Object,
      required: true
    }
  },
  components: {
    CircleProgress: CircleProgress
  },
  data () {
    return {
      skill: this.initialSkill,
      startColor: styles.startColor,
      endColor: styles.endColor
    }
  },
  methods: {
    leave () {
      const card = this.$refs.card
      const circle = this.$refs.circle
      card.style.transform = 'perspective(500px) scale(1)'
      circle.style.transform = 'perspective(500px) scale(1)'
    },
    move () {
      const card = this.$refs.card
      const circle = this.$refs.circle
      const relX = (event.offsetX + 0.5) / card.offsetWidth
      const relY = (event.offsetY + 0.5) / card.offsetHeight
      const rotY = `rotateY(${(relX - 0.25) * 20}deg)`
      const rotX = `rotateX(${(relY - 0.55) * -20}deg)`
      card.style.transform = `perspective(500px) scale(1.1) ${rotY} ${rotX}`
      circle.style.transform = `perspective(500px) scale(1.1) ${rotY} ${rotX}`
    },
    scale: (val, inMin, inMax, outMin, outMax) =>
      outMin + (val - inMin) * (outMax - outMin) / (inMax - inMin)
  }
}

</script>
<style lang="scss">
@import "../styles/global.scss";

:export {
  startColor: red ;
  endColor: blue ;
}

.skillName {
  vertical-align: center;
  text-align: center;
  padding-top: 0.5rem;
  color: $primary-base-color ;
}

.skill-card-background-color {
  width: fit-content;
  padding-top: 10px;
}

.circle {
  position: relative;
  width: fit-content;
  transition: all .9s ease;
  border-radius: 6rem;
  background-color: rgba(255, 255, 255, 0) !important;
  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.3), inset 0.4rem 0.4rem 0.7rem 0.9rem rgba(0, 0, 0, 0.2);
}

.card {
  border: 0px !important;
  background-color: rgba(255, 255, 255, 1) !important;
  width: 13.1rem;
  height: 17rem;
  padding: 15px;
  margin-left: 3rem;
  transition: all .3s ease;
  border-radius: 50px !important;
  overflow: hidden;
  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.2);
}

.card:hover {
  z-index: 2;
  box-shadow: 0 10px 20px rgba(0, 0, 0, 0.5);
}

</style>
